//GSP480 - Monte Carlo Lab
//Tylor Emmett
//4/22/15

#include "Deck.h"

Deck* Deck::Instance()
{
	static Deck instance;
	return &instance;
}

Deck::Deck()
{
	//Seed random number generator
	std::random_device rd;
	rand.seed(rd());
}

Cards::Card Deck::DrawCard()
{
	//Return a number between 0 and 12 cast to the Card enum (Cards A through K).
	std::uniform_int_distribution<unsigned> dist(0, 12);
	return (Cards::Card)dist(rand);
}

void Cards::PrintCard(Card cardIn)
{
	switch (cardIn)
	{
	case Card::A:
		std::cout << "A ";
		break;
	case Card::J:
		std::cout << "J ";
		break;
	case Card::K:
		std::cout << "K ";
		break;
	case Card::Q:
		std::cout << "Q ";
		break;
	case Card::_2:
		std::cout << "2 ";
		break;
	case Card::_3:
		std::cout << "3 ";
		break;
	case Card::_4:
		std::cout << "4 ";
		break;
	case Card::_5:
		std::cout << "5 ";
		break;
	case Card::_6:
		std::cout << "6 ";
		break;
	case Card::_7:
		std::cout << "7 ";
		break;
	case Card::_8:
		std::cout << "8 ";
		break;
	case Card::_9:
		std::cout << "9 ";
		break;
	case Card::_10:
		std::cout << "10 ";
		break;
	}
}