//GSP480 - Monte Carlo Lab
//Tylor Emmett
//4/22/15

#ifndef DECK_H
#define DECK_H

#include <random>
#include <iostream>

namespace Cards
{
	//Holds all possible card values
	enum Card{A, _2, _3, _4, _5, _6, _7, _8, _9, _10, J, Q, K};

	//Utility function for printing card to console
	void PrintCard(Card cardIn);
}

class Deck
{
	Deck();
	std::mt19937 rand;
public:
	//Singleton accessor
	static Deck* Instance();
	//Returns a card with a unifrom distribution (0 in 12 chance for any particular card)
	Cards::Card DrawCard();

	//Deleted copy/assignment for singleton.
	Deck(Deck&) = delete;
	void operator=(Deck&) = delete;
};




#endif