//GSP480 - Monte Carlo Lab
//Tylor Emmett
//4/22/15

#ifndef PLAYER_H
#define PLAYER_H

#include <vector>
#include "Deck.h"

class Player
{
	std::vector<Cards::Card> hand;	//Container for the current hand
	bool isStanding;				//Is the player standing (i.e. finished)?
	Player();						//Private constructor for singleton
public:
	friend class MonteCarlo;		//Allow MonteCarlo class to access the player's hand
	static Player* Instance();		//Accessor for this class
	void TakeTurn();				//Displays MonteCarlo stats, and prompts player to hit or stand
	void PrintHand();				//Displays current hand
	void GiveCard(Cards::Card cardIn);	//Adds a card to the player's hand
	bool IsStanding();				//Returns the value of isStanding
	void Reset();					//Clears the players hand and sets isStanding back to false
	int HandValue();				//Returns the value of the current hand.

	//Deleted copy and assignment for singleton
	Player(Player&) = delete;
	void operator=(Player&) = delete;
};

#endif